target datalayout = "e-p:64:64:64-i1:8:8-i8:8:8-i16:16:16-i32:32:32-i64:64:64-f32:32:32-f64:64:64-v16:16:16-v24:32:32-v32:32:32-v48:64:64-v64:64:64-v96:128:128-v128:128:128-v192:256:256-v256:256:256-v512:512:512-v1024:1024:1024"
target triple = "spir64-unknown-unknown"

; Function Attrs: nounwind readnone
declare spir_func <3 x i64> @__builtin_spirv_BuiltInGlobalInvocationId() #0

; Function Attrs: nounwind
define spir_kernel void @write_up(i32 addrspace(1)* %dst, i32 %length) #1 {
  %1 = call spir_func <3 x i64> @__builtin_spirv_BuiltInGlobalInvocationId() #0
  %call = extractelement <3 x i64> %1, i32 0
  %2 = getelementptr inbounds i32, i32 addrspace(1)* %dst, i64 %call
  %3 = load i32, i32 addrspace(1)* %2, align 4
  %mul = mul nsw i32 %3, 2
  store i32 %mul, i32 addrspace(1)* %2, align 4
  ret void
}

; Function Attrs: nounwind
define spir_kernel void @write_down(i32 addrspace(1)* %dst, i32 %length) #1 {
  %1 = call spir_func <3 x i64> @__builtin_spirv_BuiltInGlobalInvocationId() #0
  %call = extractelement <3 x i64> %1, i32 0
  %2 = getelementptr inbounds i32, i32 addrspace(1)* %dst, i64 %call
  %3 = load i32, i32 addrspace(1)* %2, align 4
  %dec = add nsw i32 %3, -1
  store i32 %dec, i32 addrspace(1)* %2, align 4
  ret void
}

attributes #0 = { nounwind readnone }
attributes #1 = { nounwind }

!opencl.kernels = !{!0, !7}
!IGCMetadata = !{!8}
!opencl.enable.FP_CONTRACT = !{}
!opencl.spir.version = !{!243}
!opencl.ocl.version = !{!243}
!opencl.used.extensions = !{!244}
!opencl.used.optional.core.features = !{!244}
!opencl.compiler.options = !{!245}

!0 = !{void (i32 addrspace(1)*, i32)* @write_up, !1, !2, !3, !4, !5, !6}
!1 = !{!"kernel_arg_addr_space", i32 1, i32 0}
!2 = !{!"kernel_arg_access_qual", !"none", !"none"}
!3 = !{!"kernel_arg_type", !"int*", !"int"}
!4 = !{!"kernel_arg_type_qual", !"", !""}
!5 = !{!"kernel_arg_base_type", !"int*", !"int"}
!6 = !{!"kernel_arg_name", !"dst", !"length"}
!7 = !{void (i32 addrspace(1)*, i32)* @write_down, !1, !2, !3, !4, !5, !6}
!8 = !{!"ModuleMD", !9, !10, !65, !124, !154, !170, !182, !192, !194, !195, !206, !207, !208, !209, !212, !213, !214, !215, !216, !217, !218, !219, !220, !221, !222, !223, !225, !229, !230, !231, !232, !233, !234, !109, !235, !236, !238, !241, !242}
!9 = !{!"isPrecise", i1 false}
!10 = !{!"compOpt", !11, !12, !13, !14, !15, !16, !17, !18, !19, !20, !21, !22, !23, !24, !25, !26, !27, !28, !29, !30, !31, !32, !33, !34, !35, !36, !37, !38, !39, !40, !41, !42, !43, !44, !45, !46, !47, !48, !49, !50, !51, !52, !53, !54, !55, !56, !57, !58, !59, !60, !61, !62, !63, !64}
!11 = !{!"DenormsAreZero", i1 false}
!12 = !{!"CorrectlyRoundedDivSqrt", i1 false}
!13 = !{!"OptDisable", i1 false}
!14 = !{!"MadEnable", i1 false}
!15 = !{!"NoSignedZeros", i1 false}
!16 = !{!"NoNaNs", i1 false}
!17 = !{!"FloatRoundingMode", i32 0}
!18 = !{!"FloatCvtIntRoundingMode", i32 3}
!19 = !{!"VISAPreSchedRPThreshold", i32 0}
!20 = !{!"SetLoopUnrollThreshold", i32 0}
!21 = !{!"UnsafeMathOptimizations", i1 false}
!22 = !{!"FiniteMathOnly", i1 false}
!23 = !{!"FastRelaxedMath", i1 false}
!24 = !{!"DashGSpecified", i1 false}
!25 = !{!"FastCompilation", i1 false}
!26 = !{!"UseScratchSpacePrivateMemory", i1 true}
!27 = !{!"RelaxedBuiltins", i1 false}
!28 = !{!"SubgroupIndependentForwardProgressRequired", i1 true}
!29 = !{!"GreaterThan2GBBufferRequired", i1 true}
!30 = !{!"GreaterThan4GBBufferRequired", i1 true}
!31 = !{!"DisableA64WA", i1 false}
!32 = !{!"ForceEnableA64WA", i1 false}
!33 = !{!"PushConstantsEnable", i1 true}
!34 = !{!"HasPositivePointerOffset", i1 false}
!35 = !{!"HasBufferOffsetArg", i1 false}
!36 = !{!"BufferOffsetArgOptional", i1 true}
!37 = !{!"HasSubDWAlignedPtrArg", i1 false}
!38 = !{!"replaceGlobalOffsetsByZero", i1 false}
!39 = !{!"forcePixelShaderSIMDMode", i32 0}
!40 = !{!"pixelShaderDoNotAbortOnSpill", i1 false}
!41 = !{!"UniformWGS", i1 false}
!42 = !{!"disableVertexComponentPacking", i1 false}
!43 = !{!"disablePartialVertexComponentPacking", i1 false}
!44 = !{!"PreferBindlessImages", i1 false}
!45 = !{!"UseBindlessMode", i1 false}
!46 = !{!"UseLegacyBindlessMode", i1 true}
!47 = !{!"disableMathRefactoring", i1 false}
!48 = !{!"atomicBranch", i1 false}
!49 = !{!"ForceMinSimdSizeForFastestCS", i1 false}
!50 = !{!"EnableFastestLinearScan", i1 false}
!51 = !{!"UseStatelessforPrivateMemory", i1 false}
!52 = !{!"EnableTakeGlobalAddress", i1 false}
!53 = !{!"IsLibraryCompilation", i1 false}
!54 = !{!"FastVISACompile", i1 false}
!55 = !{!"MatchSinCosPi", i1 false}
!56 = !{!"CaptureCompilerStats", i1 false}
!57 = !{!"EnableZEBinary", i1 false}
!58 = !{!"ExcludeIRFromZEBinary", i1 false}
!59 = !{!"allowDisableRematforCS", i1 false}
!60 = !{!"DisableIncSpillCostAllAddrTaken", i1 false}
!61 = !{!"DisableCPSOmaskWA", i1 false}
!62 = !{!"DisableFastestGopt", i1 false}
!63 = !{!"WaForceHalfPromotion", i1 false}
!64 = !{!"EnableUndefAlphaOutputAsRed", i1 true}
!65 = !{!"FuncMD", !66, !67, !122, !123}
!66 = !{!"FuncMDMap[0]", void (i32 addrspace(1)*, i32)* @write_up}
!67 = !{!"FuncMDValue[0]", !68, !69, !73, !74, !75, !95, !101, !102, !103, !104, !105, !106, !107, !108, !109, !110, !111, !112, !113, !114, !115, !116, !117, !118, !119, !120, !121}
!68 = !{!"localOffsets"}
!69 = !{!"workGroupWalkOrder", !70, !71, !72}
!70 = !{!"dim0", i32 0}
!71 = !{!"dim1", i32 0}
!72 = !{!"dim2", i32 0}
!73 = !{!"funcArgs"}
!74 = !{!"functionType", !"KernelFunction"}
!75 = !{!"rtInfo", !76, !77, !78, !79, !80, !81, !82, !83, !84, !85, !86, !87, !88, !89, !90, !94}
!76 = !{!"callableShaderType", !"NumberOfCallableShaderTypes"}
!77 = !{!"isContinuation", i1 false}
!78 = !{!"hasTraceRayPayload", i1 false}
!79 = !{!"hasHitAttributes", i1 false}
!80 = !{!"hasCallableData", i1 false}
!81 = !{!"ShaderStackSize", i32 0}
!82 = !{!"ShaderHash", i64 0}
!83 = !{!"ShaderName", !""}
!84 = !{!"ParentName", !""}
!85 = !{!"SlotNum", i1* null}
!86 = !{!"NOSSize", i32 0}
!87 = !{!"Entries"}
!88 = !{!"SpillUnions"}
!89 = !{!"CustomHitAttrSizeInBytes", i32 0}
!90 = !{!"Types", !91, !92, !93}
!91 = !{!"FrameStartTys"}
!92 = !{!"ArgumentTys"}
!93 = !{!"FullFrameTys"}
!94 = !{!"Aliases"}
!95 = !{!"resAllocMD", !96, !97, !98, !99, !100}
!96 = !{!"uavsNumType", i32 0}
!97 = !{!"srvsNumType", i32 0}
!98 = !{!"samplersNumType", i32 0}
!99 = !{!"argAllocMDList"}
!100 = !{!"inlineSamplersMD"}
!101 = !{!"maxByteOffsets"}
!102 = !{!"IsInitializer", i1 false}
!103 = !{!"IsFinalizer", i1 false}
!104 = !{!"CompiledSubGroupsNumber", i32 0}
!105 = !{!"hasInlineVmeSamplers", i1 false}
!106 = !{!"localSize", i32 0}
!107 = !{!"localIDPresent", i1 false}
!108 = !{!"groupIDPresent", i1 false}
!109 = !{!"privateMemoryPerWI", i32 0}
!110 = !{!"globalIDPresent", i1 false}
!111 = !{!"hasSyncRTCalls", i1 false}
!112 = !{!"hasNonKernelArgLoad", i1 false}
!113 = !{!"hasNonKernelArgStore", i1 false}
!114 = !{!"hasNonKernelArgAtomic", i1 false}
!115 = !{!"UserAnnotations"}
!116 = !{!"m_OpenCLArgAddressSpaces"}
!117 = !{!"m_OpenCLArgAccessQualifiers"}
!118 = !{!"m_OpenCLArgTypes"}
!119 = !{!"m_OpenCLArgBaseTypes"}
!120 = !{!"m_OpenCLArgTypeQualifiers"}
!121 = !{!"m_OpenCLArgNames"}
!122 = !{!"FuncMDMap[1]", void (i32 addrspace(1)*, i32)* @write_down}
!123 = !{!"FuncMDValue[1]", !68, !69, !73, !74, !75, !95, !101, !102, !103, !104, !105, !106, !107, !108, !109, !110, !111, !112, !113, !114, !115, !116, !117, !118, !119, !120, !121}
!124 = !{!"pushInfo", !125, !126, !127, !130, !131, !132, !133, !134, !135, !136, !137, !150, !151, !152, !153}
!125 = !{!"pushableAddresses"}
!126 = !{!"bindlessPushInfo"}
!127 = !{!"dynamicBufferInfo", !128, !129}
!128 = !{!"firstIndex", i32 0}
!129 = !{!"numOffsets", i32 0}
!130 = !{!"MaxNumberOfPushedBuffers", i32 0}
!131 = !{!"inlineConstantBufferSlot", i32 -1}
!132 = !{!"inlineConstantBufferOffset", i32 -1}
!133 = !{!"inlineConstantBufferGRFOffset", i32 -1}
!134 = !{!"constants"}
!135 = !{!"inputs"}
!136 = !{!"constantReg"}
!137 = !{!"simplePushInfoArr", !138, !147, !148, !149}
!138 = !{!"simplePushInfoArrVec[0]", !139, !140, !141, !142, !143, !144, !145, !146}
!139 = !{!"cbIdx", i32 0}
!140 = !{!"pushableAddressGrfOffset", i32 -1}
!141 = !{!"pushableOffsetGrfOffset", i32 -1}
!142 = !{!"offset", i32 0}
!143 = !{!"size", i32 0}
!144 = !{!"isStateless", i1 false}
!145 = !{!"isBindless", i1 false}
!146 = !{!"simplePushLoads"}
!147 = !{!"simplePushInfoArrVec[1]", !139, !140, !141, !142, !143, !144, !145, !146}
!148 = !{!"simplePushInfoArrVec[2]", !139, !140, !141, !142, !143, !144, !145, !146}
!149 = !{!"simplePushInfoArrVec[3]", !139, !140, !141, !142, !143, !144, !145, !146}
!150 = !{!"simplePushBufferUsed", i32 0}
!151 = !{!"pushAnalysisWIInfos"}
!152 = !{!"inlineRTGlobalPtrOffset", i32 0}
!153 = !{!"rtSyncSurfPtrOffset", i32 0}
!154 = !{!"psInfo", !155, !156, !157, !158, !159, !160, !161, !162, !163, !164, !165, !166, !167, !168, !169}
!155 = !{!"BlendStateDisabledMask", i8 0}
!156 = !{!"SkipSrc0Alpha", i1 false}
!157 = !{!"DualSourceBlendingDisabled", i1 false}
!158 = !{!"ForceEnableSimd32", i1 false}
!159 = !{!"outputDepth", i1 false}
!160 = !{!"outputStencil", i1 false}
!161 = !{!"outputMask", i1 false}
!162 = !{!"blendToFillEnabled", i1 false}
!163 = !{!"forceEarlyZ", i1 false}
!164 = !{!"hasVersionedLoop", i1 false}
!165 = !{!"forceSingleSourceRTWAfterDualSourceRTW", i1 false}
!166 = !{!"NumSamples", i8 0}
!167 = !{!"blendOptimizationMode"}
!168 = !{!"colorOutputMask"}
!169 = !{!"WaDisableVRS", i1 false}
!170 = !{!"csInfo", !171, !172, !173, !174, !175, !19, !20, !176, !177, !178, !179, !180, !48, !181}
!171 = !{!"maxWorkGroupSize", i32 0}
!172 = !{!"waveSize", i32 0}
!173 = !{!"ComputeShaderSecondCompile"}
!174 = !{!"forcedSIMDSize", i8 0}
!175 = !{!"forceTotalGRFNum", i32 0}
!176 = !{!"forcedVISAPreRAScheduler", i1 false}
!177 = !{!"disableLocalIdOrderOptimizations", i1 false}
!178 = !{!"disableDispatchAlongY", i1 false}
!179 = !{!"neededThreadIdLayout", i1* null}
!180 = !{!"forceTileYWalk", i1 false}
!181 = !{!"ResForHfPacking"}
!182 = !{!"msInfo", !183, !184, !185, !186, !187, !188, !189, !190, !191}
!183 = !{!"PrimitiveTopology", i32 3}
!184 = !{!"MaxNumOfPrimitives", i32 0}
!185 = !{!"MaxNumOfVertices", i32 0}
!186 = !{!"MaxNumOfPerPrimitiveOutputs", i32 0}
!187 = !{!"MaxNumOfPerVertexOutputs", i32 0}
!188 = !{!"WorkGroupSize", i32 0}
!189 = !{!"WorkGroupMemorySizeInBytes", i32 0}
!190 = !{!"IndexFormat", i32 6}
!191 = !{!"SubgroupSize", i32 0}
!192 = !{!"taskInfo", !193, !188, !189, !191}
!193 = !{!"MaxNumOfOutputs", i32 0}
!194 = !{!"NBarrierCnt", i32 0}
!195 = !{!"rtInfo", !196, !197, !198, !199, !200, !201, !202, !203, !204, !205}
!196 = !{!"RayQueryAllocSizeInBytes", i32 0}
!197 = !{!"NumContinuations", i32 -1}
!198 = !{!"RTAsyncStackAddrspace", i32 -1}
!199 = !{!"RTAsyncStackSurfaceStateOffset", i1* null}
!200 = !{!"SWHotZoneAddrspace", i32 -1}
!201 = !{!"SWHotZoneSurfaceStateOffset", i1* null}
!202 = !{!"SWStackAddrspace", i32 -1}
!203 = !{!"SWStackSurfaceStateOffset", i1* null}
!204 = !{!"RTSyncStackAddrspace", i32 -1}
!205 = !{!"RTSyncStackSurfaceStateOffset", i1* null}
!206 = !{!"CurUniqueIndirectIdx", i32 0}
!207 = !{!"inlineDynTextures"}
!208 = !{!"inlineResInfoData"}
!209 = !{!"immConstant", !210, !211}
!210 = !{!"data"}
!211 = !{!"sizes"}
!212 = !{!"inlineConstantBuffers"}
!213 = !{!"inlineGlobalBuffers"}
!214 = !{!"GlobalPointerProgramBinaryInfos"}
!215 = !{!"ConstantPointerProgramBinaryInfos"}
!216 = !{!"GlobalBufferAddressRelocInfo"}
!217 = !{!"ConstantBufferAddressRelocInfo"}
!218 = !{!"forceLscCacheList"}
!219 = !{!"SrvMap"}
!220 = !{!"RasterizerOrderedByteAddressBuffer"}
!221 = !{!"MinNOSPushConstantSize", i32 0}
!222 = !{!"inlineProgramScopeOffsets"}
!223 = !{!"shaderData", !224}
!224 = !{!"numReplicas", i32 0}
!225 = !{!"URBInfo", !226, !227, !228}
!226 = !{!"has64BVertexHeaderInput", i1 false}
!227 = !{!"has64BVertexHeaderOutput", i1 false}
!228 = !{!"hasVertexHeader", i1 true}
!229 = !{!"UseBindlessImage", i1 false}
!230 = !{!"enableRangeReduce", i1 false}
!231 = !{!"allowMatchMadOptimizationforVS", i1 false}
!232 = !{!"disableMemOptforNegativeOffsetLoads", i1 false}
!233 = !{!"statefulResourcesNotAliased", i1 false}
!234 = !{!"disableMixMode", i1 false}
!235 = !{!"PrivateMemoryPerFG"}
!236 = !{!"capabilities", !237}
!237 = !{!"globalVariableDecorationsINTEL", i1 false}
!238 = !{!"m_ShaderResourceViewMcsMask", !239, !240}
!239 = !{!"m_ShaderResourceViewMcsMaskVec[0]", i64 0}
!240 = !{!"m_ShaderResourceViewMcsMaskVec[1]", i64 0}
!241 = !{!"computedDepthMode", i32 0}
!242 = !{!"isHDCFastClearShader", i1 false}
!243 = !{i32 3, i32 0}
!244 = !{}
!245 = !{!"-cl-std=CL3.0"}
